

import * as server from '@minecraft/server'

import { getScore, onionInterface, esfericasACartesianas, pikSpawnSeeds , OWNER_NAME_PREFIX, yellowPikminSpark,purplePikminThud,setPikminGrabCordinates,pikminGrabDamage,pikSpawnNectar,wingedPikminCarryPlayer,wingedShouldTellStamina} from './pikFuntions'
import { openPiklopedia } from './piklopedia'


export const maxWingedStamina = 600
const world = server.world
const system = server.system
const pikScoreboardObjectiveNames = [`pseeds`,`pikSpicyExtract`,`pikmin_grab`,`creative_test`,`anger_timer`,`hpik`,`wanted_pik`,`pik_ground`,`pik_on_head`,`pik_look_down`,`pGrabX`,`pGrabY`,`pGrabZ`]
var pik_look_down = undefined
var pikSpicyExtract = undefined
var obX = undefined
var obY = undefined
var obZ = undefined






world.afterEvents.worldInitialize.subscribe((data)=>{
    pikScoreboardObjectiveNames.forEach(scoreboardObjectiveName=>{
      try{
        world.scoreboard.addObjective(scoreboardObjectiveName,"")
      }catch{
        console.warn(``)
      }
    })
    pikSpicyExtract =  world.scoreboard.getObjective("pikSpicyExtract")
    pik_look_down =  world.scoreboard.getObjective("pik_look_down")
    obX = world.scoreboard.getObjective(`pGrabX`)
    obY = world.scoreboard.getObjective(`pGrabY`)
    obZ= world.scoreboard.getObjective(`pGrabZ`)
    
    try{
      world.scoreboard.setObjectiveAtDisplaySlot("List",{objective: pikSpicyExtract})
    }
    catch{
      console.warn(``)
    }
    try{
      world.scoreboard.setObjectiveAtDisplaySlot("BelowName",{objective: pikmin_grab})
    }
    catch{
      console.warn(``)
    }
    
    let pikminCraftPlayerProperties = new server.DynamicPropertiesDefinition()
    pikminCraftPlayerProperties.defineNumber(`wingedStamina`,maxWingedStamina)
    data.propertyRegistry.registerEntityTypeDynamicProperties(pikminCraftPlayerProperties,'minecraft:player')
})

function pikminGrabTeleport(pikmin){
 
  

  const obX = world.scoreboard.getObjective(`pGrabX`)
  const obY = world.scoreboard.getObjective(`pGrabY`)
  const obZ = world.scoreboard.getObjective(`pGrabZ`)
 
  const {target} = pikmin


  

  const {location: l} = target
  
  const x = (l.x   +   (obX.getScore(pikmin)/10))
  const y = (l.y   +   (obY.getScore(pikmin)/10))
  const z = (l.z   +   (obZ.getScore(pikmin)/10))
  pikmin.teleport({x: x, y: y, z: z },{facingLocation: l})
  

}


system.runInterval(() => {
  
  
  world.getAllPlayers().forEach(player => {
  //Every tick, for all players present in said tick, test if they are looking at a block and
  //not looking at an entity, changuing a scoreboard as result
    const mainHand =player.getComponent("equippable").getEquipment(server.EquipmentSlot.Mainhand)
    const offHand =player.getComponent("equippable").getEquipment(server.EquipmentSlot.Offhand)
    wingedPikminCarryPlayer(player,mainHand,offHand)
      if( mainHand && mainHand.typeId.includes("pikmin_item") ){
        let en = player.getEntitiesFromViewDirection({maxDistance: 4.5 })
        let v = player.getBlockFromViewDirection({maxDistance:4.5})
        if(mainHand.typeId === `pik:purple_pikmin_item` && player.isSneaking ){
          player.onScreenDisplay.setActionBar({"rawtext":[{"translate":"pik.throw_mode.carry_mob"}]})
        }else{
          if (en[0] == null && v && !v.block.typeId.includes(`pellet_posy`)) {
            //player.runCommand("/scoreboard players set @s pik_look_down 1");
            pik_look_down.setScore(player,1)
            if(!wingedShouldTellStamina(player)){

              player.onScreenDisplay.setActionBar({"rawtext":[{"translate":"pik.throw_mode.follow"}]})
            }

            
          }else{   
            //player.runCommand("/scoreboard players set @s pik_look_down 0");
            pik_look_down.setScore(player,0)
            if( !wingedShouldTellStamina(player)){

              
              player.onScreenDisplay.setActionBar({"rawtext":[{"translate":"pik.throw_mode.default"}]})
            }
          }
        }
      }


    })
    
    
},2)
//Manage the spicy extract timer an effects

system.runInterval(()=>{
 
  world.getAllPlayers().forEach(player =>{
    if(pikSpicyExtract.getScore(player) > 0){
      //if(player.hasTag("pikSpicyExtract")){
        //player.runCommandAsync("/scoreboard players remove @s pikSpicyExtract 1")
        pikSpicyExtract.setScore(player,getScore("pikSpicyExtract",player)-1)
        const {location, dimension } = player
        var pikmins = dimension.getEntities({location, name: OWNER_NAME_PREFIX+player.name, excludeTags: ["from_onion"], families:["pikmin"], excludeFamilies: ["onion"]})
        pikmins.forEach(pikmin=>{
          pikmin.addEffect("strength",30,{showParticles:false,amplifier:3})
          pikmin.addEffect("speed",30,{showParticles:false,amplifier:3})
        })
      }
  })
  
},20)





world.afterEvents.itemUse.subscribe(({itemStack,source})=>{
  if(itemStack.typeId === `pik:piklopedia` && source.typeId === `minecraft:player`){
    openPiklopedia(source)
  }
})




world.afterEvents.entityHitEntity.subscribe(  result => {
  //If a player hits an onion with its same name
  if ( (result.hitEntity.typeId.includes("onion")) && (( OWNER_NAME_PREFIX+result.damagingEntity.name) === result.hitEntity.nameTag)) {
    //result.hitEntity.runCommandAsync("/say Hitted by "+result.entity.typeId)
    //Gets the typeId of the item version of the related pikmin type
    onionInterface(result.damagingEntity,result.hitEntity)
    
  }

},{entityTypes:['minecraft:player']})

world.afterEvents.entityHurt.subscribe(  result => {
  if(result.hurtEntity){
    const {hurtEntity,damage} = result
    const {dimension,location} = hurtEntity
    const ghast = dimension.getEntities({closest: 1, type: `minecraft:ghast`})[0]
    ghast.applyDamage(damage)
   }

},{entityTypes:['pik:ghast_hitbox']})


//Event listeners------------------------------------------------------------------------


//Renames Tamed Onions to it´s owner´s name

world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {
  const { location, dimension } = data.entity
  const player = dimension.getPlayers({ location, maxDistance: 6,closest:1 })[0]
  
  data.entity.nameTag = OWNER_NAME_PREFIX+player.name
}, { eventTypes: ['rename'] })

//Renames Pikmin from tamed onions to it´s owner´s name
world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {
  const onionTypeId = data.entity.typeId.substring(0,data.entity.typeId.indexOf("pikmin"))+"onion"
  const { location, dimension } = data.entity
  const onion = dimension.getEntities({ location, maxDistance: 6,type: onionTypeId,closest: 1 })[0]
  data.entity.nameTag = onion.nameTag
}, { eventTypes: ['from_onion'] })
//Renames Thrown Pikmin to it´s owner's name

world.afterEvents.entitySpawn.subscribe(({entity}) => {
const {typeId} = entity
if (typeId.includes(`pik:throw_`)){
  const { location, dimension } = entity
  const player = dimension.getPlayers({ location, closest:1 })[0]
  
  entity.nameTag = OWNER_NAME_PREFIX+player.name
  if(pikSpicyExtract.getScore(player)>0){
    entity.triggerEvent("add_spice")
  } 
}
if (typeId === `minecraft:item`){
  const item = entity.getComponent('item').itemStack
  if(item.typeId.includes(`pikmin_item`)){
  
      const{dimension,location} = entity
      const {x,z} = location
      const pikminTypeId = item.typeId.substring(0,item.typeId.indexOf("_item"))
      const vel = entity.getVelocity()
      const velMultiplier = 2
      for (let i = 0; i < item.amount; i++) {
        let pikmin = dimension.spawnEntity(`${pikminTypeId}<lost>`,location)
        pikmin.applyImpulse({x:vel.x*velMultiplier,y:vel.y*velMultiplier,z:vel.z*velMultiplier})
      }
    entity.teleport({x,y:-100,z})
  }
  if(item.typeId.includes(`onion_item`)){
  
    const{dimension,location} = entity
    const {x,z} = location
    const onionTypeId = item.typeId.substring(0,item.typeId.indexOf("_item"))
    const vel = entity.getVelocity()
    const velMultiplier = 2
    for (let i = 0; i < item.amount; i++) {
      let pikmin = dimension.spawnEntity(`${onionTypeId}<minecraft:entity_spawned>`,location)
      pikmin.applyImpulse({x:vel.x*velMultiplier,y:vel.y*velMultiplier,z:vel.z*velMultiplier})
    }
  entity.teleport({x,y:-100,z})
}
}
})



//triggers when pikmin goes to onion
world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {
  if(data.entity.hasTag(`from_onion`)){
  const onionTypeId = data.entity.typeId.substring(0,data.entity.typeId.indexOf("pikmin"))+"onion"
  
  const {dimension,location,nameTag} = data.entity

  const onion = dimension.getEntities({closest: 1, type: onionTypeId, name: nameTag, location})[0]
  data.entity.applyDamage(0.1,{cause: `entityAttack`,damagingEntity: onion})
  data.entity.clearVelocity()
  data.entity.removeTag(`from_onion`)
  data.entity.addTag(`to_onion`)
 
  
  }
}, { eventTypes: ['to_onion'] })

//Trigger when onion calls pikmin
world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {
  const { location, dimension,nameTag } = data.entity
  const pikminTypeId = data.entity.typeId.substring(0,data.entity.typeId.indexOf("onion"))+"pikmin"
  
  const pikmins = dimension.getEntities({type: pikminTypeId, closest: 20,name: nameTag ,tags: [`from_onion`]})
  pikmins.forEach(pikmin =>{
    pikmin.triggerEvent(`to_onion`)
    
  })

}, { eventTypes: ['call_pikmins'] })

world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {
  const nutrients = getScore('pseeds',data.entity,true)
  const pikminToSpawn = Math.floor(nutrients/2)
  pikSpawnSeeds(data.entity,pikminToSpawn,4)
  const pseeds = world.scoreboard.getObjective('pseeds')
  pseeds.setScore(data.entity,nutrients-pikminToSpawn*2)
}, { eventTypes: ['spit_seed'] })

world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {
  const cp_pseeds = world.scoreboard.getObjective('cp_pseeds')
  const cp_cseeds = world.scoreboard.getObjective('cp_cseeds')
  const pikminToSpawn = cp_pseeds.getScore(data.entity)
  let pikminSpawned = cp_cseeds.getScore(data.entity)
  if (pikminSpawned == undefined){pikminSpawned = 0}
  pikSpawnSeeds(data.entity,pikminToSpawn,1)
  
  console.warn(pikminSpawned)
  cp_pseeds.setScore(data.entity,0)
  cp_cseeds.setScore(data.entity,pikminSpawned+pikminToSpawn)
}, { eventTypes: ['shoot_seed'] })

world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {
  const alpha = 2*3.1416*Math.random()

  
  const {x: vx ,y: vy,z: vz} = esfericasACartesianas(0.75,alpha,3.1416*(1/4))
  //data.entity.applyImpulse({x: Math.sin(angle),y: Math.cos(angle),z: 1})
  //applyAngledImpulse(data.entity,Math.floor(Math.random()*360),30,1)
  data.entity.applyImpulse({x: vx, y: vz, z: vy} )
  data.entity.setRotation({x:0,y:(alpha)*(180/3.1416)})
}, { eventTypes: ['pik_seed_random_knockback'] })

//Transfers items from pikmin to player

world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {
  if(data.entity){
    const playerName = data.entity.nameTag.replace(OWNER_NAME_PREFIX,``)
    
    const players = world.getPlayers({name: playerName})
    if((players.length == 1) ){
      const slots = [
        server.EquipmentSlot.Mainhand,server.EquipmentSlot.Head,server.EquipmentSlot.Chest,server.EquipmentSlot.Legs,server.EquipmentSlot.Feet]
      const player = players[0]
      const {dimension,location} = player
      



      
      
      const pInventory = player.getComponent('inventory').container
      
      system.runTimeout(() => {
        const itemsEntity = dimension.getEntities({type: `minecraft:item`,maxDistance: 2, location})
        let items = []
        itemsEntity.forEach(itemEntity=>{
          items.push(itemEntity.getComponent('item').itemStack)
          itemEntity.remove()
        })
        system.runTimeout(() => {
          items.forEach(item=>{
            let residue = pInventory.addItem(item)
            
            
            if (residue){
              dimension.spawnItem(residue,location)
            }
          })
          
        }, 2);
      }, 2);

      
      

      
        
      
  
      }  

  }
}, { eventTypes: ['pik_t_item'] })
world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {
  //data.entity.kill()
  
  yellowPikminSpark(data.entity)
  
}, { eventTypes: ["spark"] })
world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {
  //purplePikminThud(entity)
  purplePikminThud(data.entity)
}, { eventTypes: ['thup'] })
world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {
  const {entity} = data
  setPikminGrabCordinates(entity)
  const pikmin_grab =  world.scoreboard.getObjective("pikmin_grab")
  let keepCycle = true
  entity.playAnimation(`animation.pikmin.grab`, {stopExpression: `!(query.scoreboard('pikmin_grab')==1)`})
  const id = system.runInterval(()=>{
    try{
      let score = pikmin_grab.getScore(entity)
      if(score!=1){
        keepCycle = false
      }
    }catch{
      keepCycle = false
    }

 
   
    if(!keepCycle || !entity.target){
      
      system.clearRun(id)
    }else{
      
      pikminGrabTeleport(entity)
      
    }
  },3)

}, { eventTypes: ['grab'] })
world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {
  
  pikminGrabDamage(data.entity)
}, { eventTypes: ['teleport_to_target'] })

world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {
  
    const rotation = ((data.entity.getRotation().x)%360)*(3.1416/180)
    const {x: vx ,y: vy,z: vz} = esfericasACartesianas(1,rotation,3.1416*(0.3))
    system.runTimeout(() => {
      
      data.entity.applyImpulse({x: vx, y: vz, z: vy} )
      //data.entity.playAnimation(`animation.pikmin.shaken_off`,{blendOutTime: 9999,stopExpression: `query.is_on_ground`})
  }, 2 );
  
  
}, { eventTypes: ['shaken_off'] })
//Deeath Listeners -------------------------------------------------------------------------------------------------------




//Generates spicy spray and crystalized nectar
world.afterEvents.entityDie.subscribe(({damageSource,deadEntity})=>{
  try{
  if (deadEntity && damageSource.damagingEntity && damageSource.damagingEntity.typeId.includes(`pikmin`)){
    const {dimension, location } = deadEntity

    

    

        if(Math.random()<=0.45){
          dimension.spawnEntity(`pik:spicy_blob`,location)
        }

        if(Math.random()<=0.7){
          pikSpawnNectar(deadEntity)
        }
      
      
    
  }
  }catch{
    console.warn(``)
  }
})


