import * as server from '@minecraft/server'

import * as ui from '@minecraft/server-ui'

const entries = [
    {
        id: `main`,
        title: `piklopedia.main.title`,
        body: `piklopedia.main.body`,
        buttons: [
            {
                text: `piklopedia.pikminGeneral.title`,
                returnedValue: `pikminGeneral`,
                iconPath: `textures/items/red_pikmin`
            },
            {
                text: `piklopedia.onions.title`,
                returnedValue: `onions`,
                iconPath: `textures/items/purple_onion`
            },
            {
                text: `piklopedia.candypopBuds.title`,
                returnedValue: `candypopBuds`,
                iconPath: `textures/items/candypop`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `pikminGeneral`,
        title: `piklopedia.pikminGeneral.title`,
        body: `piklopedia.pikminGeneral.body`,
        buttons: [
            {
                text: `piklopedia.pikminTypes.title`,
                returnedValue: `pikminTypes`,
                iconPath: `textures/items/blue_pikmin`
            },
            {
                text: `piklopedia.pikminControls.title`,
                returnedValue: `pikminControls`,
                iconPath: `textures/items/pikmin_whistle`
            },
            {
                text: `piklopedia.spicySpray.title`,
                returnedValue: `spicySpray`,
                iconPath: `textures/items/spicy_extract`
            },
            {
                text: `piklopedia.main.title`,
                returnedValue: `main`,
                iconPath: `textures/icons/back`

            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `pikminTypes`,
        title: `piklopedia.pikminTypes.title`,
        body: `piklopedia.pikminTypes.body`,
        buttons: [
            {
                text: `piklopedia.redPikmin.title`,
                returnedValue: `redPikmin`,
                iconPath: `textures/items/red_pikmin`
            },
            {
                text: `piklopedia.yellowPikmin.title`,
                returnedValue: `yellowPikmin`,
                iconPath: `textures/items/yellow_pikmin`
            },
            {
                text: `piklopedia.bluePikmin.title`,
                returnedValue: `bluePikmin`,
                iconPath: `textures/items/blue_pikmin`
            },
            {
                text: `piklopedia.whitePikmin.title`,
                returnedValue: `whitePikmin`,
                iconPath: `textures/items/white_pikmin`
            },
            {
                text: `piklopedia.purplePikmin.title`,
                returnedValue: `purplePikmin`,
                iconPath: `textures/items/purple_pikmin`
            },
            {
                text: `piklopedia.wingedPikmin.title`,
                returnedValue: `wingedPikmin`,
                iconPath: `textures/items/winged_pikmin`
            },
            {
                text: `piklopedia.pikminGeneral.title`,
                returnedValue: `pikminGeneral`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `pikminControls`,
        title: `piklopedia.pikminControls.title`,
        body: `piklopedia.pikminControls.body`,
        buttons: [
            {
                text: `piklopedia.pikminGeneral.title`,
                returnedValue: `pikminGeneral`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `onions`,
        title: `piklopedia.onions.title`,
        body: `piklopedia.onions.body`,
        buttons: [
            {
                text: `piklopedia.getOnions.title`,
                returnedValue: `getOnions`,
                iconPath: `textures/items/sugar`
            },
            {
                text: `piklopedia.onionControls.title`,
                returnedValue: `onionControls`,
                iconPath: `textures/items/pikmin_whistle`
            },
            {
                text: `piklopedia.onionColony.title`,
                returnedValue: `onionColony`,
                iconPath: `textures/icons/pellet1_stack2`
            },
            {
                text: `piklopedia.pelletPosies.title`,
                returnedValue: `pelletPosies`,
                iconPath: `textures/icons/pellet_posy`
            },
            {
                text: `piklopedia.feedOnion.title`,
                returnedValue: `feedOnion`,
                iconPath: `textures/icons/cnectar`
            },
            {
                text: `piklopedia.main.title`,
                returnedValue: `main`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `getOnions`,
        title: `piklopedia.getOnions.title`,
        body: `piklopdia.getOnions.body`,
        buttons: [
            {
                text: `piklopedia.onions.title`,
                returnedValue: `onions`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `onionControls`,
        title: `piklopedia.onionControls.title`,
        body: `piklopedia.onionControls.body`,
        buttons: [
            {
                text: `piklopedia.onions.title`,
                returnedValue: `onions`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `onionColony`,
        title: `piklopedia.onionColony.title`,
        body: `piklopedia.onionColony.body`,
        buttons: [
            {
                text: `piklopedia.onions.title`,
                returnedValue: `onions`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `pelletPosies`,
        title: `piklopedia.pelletPosies.title`,
        body: `piklopedia.pelletPosies.body`,
        buttons: [
            {
                text: `piklopedia.onions.title`,
                returnedValue: `onions`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `candypopBuds`,
        title: `piklopedia.candypopBuds.title`,
        body: `piklopedia.candypopBuds.body`,
        buttons: [
            {
                text: `piklopedia.main.title`,
                returnedValue: `main`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `feedOnion`,
        title: `piklopedia.feedOnion.title`,
        body: `piklopedia.feedOnion.body`,
        buttons: [
            {
                text: `piklopedia.onions.title`,
                returnedValue: `onions`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `spicySpray`,
        title: `piklopedia.spicySpray.title`,
        body: `piklopedia.spicySpray.body`,
        buttons: [
            {
                text: `piklopedia.pikminGeneral.title`,
                returnedValue: `pikminGeneral`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `redPikmin`,
        title: `piklopedia.redPikmin.title`,
        body: `piklopedia.redPikmin.body`,
        buttons: [
            {
                text: `piklopedia.pikminTypes.title`,
                returnedValue: `pikminTypes`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `bluePikmin`,
        title: `piklopedia.bluePikmin.title`,
        body: `piklopedia.bluePikmin.body`,
        buttons: [
            {
                text: `piklopedia.pikminTypes.title`,
                returnedValue: `pikminTypes`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `yellowPikmin`,
        title: `piklopedia.yellowPikmin.title`,
        body: `piklopedia.yellowPikmin.body`,
        buttons: [
            {
                text: `piklopedia.pikminTypes.title`,
                returnedValue: `pikminTypes`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `whitePikmin`,
        title: `piklopedia.whitePikmin.title`,
        body: `piklopedia.whitePikmin.body`,
        buttons: [
            {
                text: `piklopedia.pikminTypes.title`,
                returnedValue: `pikminTypes`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `purplePikmin`,
        title: `piklopedia.purplePikmin.title`,
        body: `piklopedia.purplePikmin.body`,
        buttons: [
            {
                text: `piklopedia.pikminTypes.title`,
                returnedValue: `pikminTypes`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    },
    {
        id: `wingedPikmin`,
        title: `piklopedia.wingedPikmin.title`,
        body: `piklopedia.wingedPikmin.body`,
        buttons: [
            {
                text: `piklopedia.pikminTypes.title`,
                returnedValue: `pikminTypes`,
                iconPath: `textures/icons/back`
            }
        ],
        form: new ui.ActionFormData()
    }

]


function setUpActionForm(entry,usesRawText = false){
    const {title,form,body,buttons} = entry;
    if(usesRawText){
        form.title({"rawtext":[{"translate":`${title}`,"with":["\n"]}]})
        form.body({"rawtext":[{"translate":`${body}`,"with":["\n"]}]})
    }else{
        form.title(title)
        form.body(body)
    }
    buttons.forEach(button => {
        if(usesRawText){
            if(button.iconPath){
                form.button( {"rawtext":[{"translate":`${button.text}`,"with":["\n"]}]},button.iconPath)
            }else{
                form.button( {"rawtext":[{"translate":`${button.text}`,"with":["\n"]}]})
            }
            
        }else{
            if(button.iconPath){
                form.button(button.text,button.iconPath)
            }else{
                form.button(button.text)
            }
        }
    })
}


function navigateActionForms(entries,id,player){
    let entry = undefined
    entries.forEach(testEntry => {
        if(testEntry.id == id){
            entry = testEntry
            
        }
    })
    
    if(!entry){
        return
    }else{
        const {form,buttons} = entry
        form.show(player).then(onFulfilled =>{
            try{
            if(!onFulfilled.cancelled){
                const {selection} = onFulfilled
                const nextId = buttons[selection].returnedValue

                navigateActionForms(entries,nextId,player)
            }
            }catch{
                console.warn(``)
            }
        })
    }
}

entries.forEach(entry=>{
    setUpActionForm(entry,true)
})

export function openPiklopedia(player){
    navigateActionForms(entries,`main`,player)
}